<?php
/****************
* campaignsplit.php
* (C) Copyright Rendham LLP 2010-2011
*
* Author: Bill Burey
* Description: Split a form posting multiple campaigns and send them onto Verify
*
* 17Sep18 @CR
* Created as GENERIC posttoverify.php called as standard for ALL web forms that require the posttoverify process
******************/

require_once ("/home/verify/public_html/common/debug.php");
require_once ("/home/verify/public_html/opendatabase_verify.php");
require_once ("/home/verify/public_html/clean_query.php");
require_once("/home/verify/public_html/common/mailjet_api_add_to_list.php"); // added 14Dec16 @CR
require_once("/home/verify/public_html/common/write_domain_campaign_record.inc.php"); // added 20Sep18 @CR

fdebug ("server.array=>" . print_r($_SERVER,true) . "<");

if (empty($_REQUEST)) {
    // nothing sent to this program - abort - intro 17Oct18 @CR
   fdebug ("no.data.sent.to.posttoverify");
   exit(0);
} //endif

fdebug ("in posttoverify");

opendatabase();

// AFFILIATE CODE
//fdebug ("posttoverify.request=>" . print_r($_REQUEST,true) . "<");
session_start();

foreach ($_REQUEST as $key => $value) {
    $skey = "'" . $key . "'";
    $_SESSION[$skey] = $value;
    //fdebug ("posttoverify.sesskey=>" . $_SESSION[$skey] . "<");
    //fdebug ("posttoverify.skey=>" . $skey . "<");
} //endforeach
// to here - AFFILIATE CODE

//fdebug ("posttoverify.session=>" . print_r($_SESSION,true) . "<");

$supplier_id = RTRIM($_REQUEST['supplier_id']);
$campaigns = RTRIM($_REQUEST['campaigns']);

$password = cleanQuery(RTRIM($_REQUEST['m_password']));
$email = cleanQuery(RTRIM($_REQUEST['m_email']));
$nextpage = cleanQuery(RTRIM($_REQUEST['nextpage']));

//$campaign_list = explode(',',$campagns);
$campaign_list = preg_split('/,/', $campaigns, -1, PREG_SPLIT_OFFSET_CAPTURE);

for ($i=0; $i<count($campaign_list); $i++) {
    $cl = "c" . $campaign_list[$i][0] . "_";
    $il = strlen($cl);
}

// re POST variables (prefixes) from form that called this program ...
$standard_form_input = "m_"; // standard prefix for an input form variable
$checkbox_form_input = "c_"; // checkbox prefix for an input form variable

// First of all build up an array of all the MAIN fields.
// Loop round all POST fields.

while (list($key,$value) = each($_POST)) {

    fdebug ("postkey=>" . $key . "<key=>" . $value . "<");

    if (substr($key,0,2) == $standard_form_input || substr($key,0,2) == $checkbox_form_input) {

        if (substr($key,0,2) == $checkbox_form_input && $value == "") {
            fdebug ("checkbox>" . $value . "<");
            // checkbox POST variable was not ticked (checked) so give it a default value of "N" (ie false)
            $value = "N";
        } //endif

        $il = strlen($key) - 2;
        $core[] = array(substr($key,2),$value);
        fdebug ("corex=>" .  print_r($core,true) . "<");

    } else if( strtolower($key) == "addr1" || strtolower($key) == "addr2" || strtolower($key) == "addr3" || strtolower($key) == "town" ||  strtolower($key) == "county" || strtolower($key) == "business_name") {
        // added business_name in the or condition above - 9May16 @CR
        $core[] = array($key,$value);
    } else {
        // Now loop through all the campaigns
        for ($i=0; $i<count($campaign_list); $i++) {
            $campaign_id = $campaign_list[$i][0];

            $_SESSION['campaign_id'] = $campaign_id; // new 18Sep18 @CR

            fdebug ("sess.cid=>" . $_SESSION['campaign_id'] . "<cid=>" . $campaign_id . "<"); //added 26Sep18 @CR

            $cl = "c" . $campaign_list[$i][0] . "_";
            $il = strlen($cl);
            if (substr($key,0,$il) == $cl) {
                $campaign[$campaign_id][] = array( substr($key,$il), $value);
            } //endif
        } //endfor
    }
} //endwhile

//***************************************************************************
// introduced 20Sep18 @CR
//
//$_SESSION['http_origin'] = $_SERVER['HTTP_ORIGIN']; eg. called from domain.co.uk
//$http_origin = $_SESSION['http_origin'];
//$_SESSION['http_referer'] = $_SERVER['HTTP_REFERER']; eg. domain.co.uk/ppi/phpscript.php
$http_referer = $_SERVER['HTTP_REFERER']; // eg. domain.co.uk/ppi/phpscript.php
$web_code = $_POST['web_code'];
fdebug ("web_code=>" . $web_code . "<");
if (!empty($http_referer)) {
    writeDomainCampaignRecord($http_referer,$campaign_id,$web_code);
    fdebug ("1.after.write.domain.camp.record");
} //endif
fdebug ("2.after.write.domain.camp.record");
//
// to here - introduced 20Sep18 @CR
//***************************************************************************


//***************************************************************************
// introduced 14Aug17 @CR
$web_reg_post_fields = array(
    'web_code',
    'supplier_id',
    'consumer_ip_address',
    'title',
    'firstname',
    'surname',
    'addr1',
    'addr2',
    'addr3',
    'town',
    'county',
    'postcode',
    'email',
    'phone',
    'dob');
fdebug ("posttoverify.core.array=>" . print_r($core,true) . "<");
// loop thru core key fields - those that form a part of the registration details should be captured
// in readiness for writing the registration record
for ($i=0; $i<count($core); $i++) {

    if (in_array($core[$i][0],$web_reg_post_fields)) {
        fdebug ("core.key=>" . $core[$i][0] . "< of value=>" . $core[$i][1] . "<should be captured for webreg.write");
        $core_key = $core[$i][0];
        $$core_key = $core[$i][1];
        fdebug ("variable=>" . $core_key . "<value=>" . $$core_key . "<");
    } //endif

} //endfor

$registered_recently = 0;

// web registration record is written to here ...

// first check this record has not already been written to web registration table recently (ie within last 3 months)...

$sql = "select count(*) as cnt from web_registration where (phone = '" . $phone . "' or email = '" . $email . "')";
$sql .= " and date_registered >= (now() - interval 3 month);";

$result = mysql_query($sql,$connection);

if (!$result) {
    fdebug ("bad.sql=>" . $sql . "<");
    $registered_recently = -1; // fault
} //endif

if ($result_row = mysql_fetch_assoc($result)) {
    if (empty($result_row['cnt'])) {
        // new registration - ie not registered within past 3 months
        $registered_recently = 0;
    } else {
        // ie registered within past 3 months - dont proceed further
        $registered_recently = 1;
    } //endif
} //endif

if (empty($registered_recently)) {

    $web_code = $_POST['web_code'];
    $supplier_id = $_POST['supplier_id'];

    $sql = "insert into web_registration (";
    $sql .= "web_code,supplier_id,posting_ip_address,title,firstname,surname,addr1,addr2,addr3,";
    $sql .= "town,county,postcode,email,phone,dob) values ";
    $sql .= "('" . cleanQuery($web_code) . "','" . cleanQuery($supplier_id) . "','" . cleanQuery($consumer_ip_address) . "'";
    $sql .= ",'" . cleanQuery($title) . "','" . cleanQuery($firstname) . "','" . cleanQuery($surname) . "'";
    $sql .= ",'" . cleanQuery($addr1) . "','" . cleanQuery($addr2) . "'";
    $sql .= ",'" . cleanQuery($addr3) . "','" . cleanQuery($town) . "','" . cleanQuery($county) . "'";
    $sql .= ",'" . cleanQuery($postcode) . "','" . cleanQuery($email) . "'";
    $sql .= ",'" . cleanQuery($phone) . "','" . cleanQuery($dob) . "');";

    $result = mysql_query($sql,$connection);

    if (!$result) {
        fdebug ("bad.sql=>" . $sql . "<");
    } //endif

    // successful write to web registration table
    // initialise these session vars for use in offerboard
    $_SESSION['web_reg_uid'] = mysql_insert_id($connection);
    $_SESSION['web_code'] = $web_code; // reintroduced 15Aug17 @CR
    $_SESSION['supplier_id'] = $supplier_id; // reintroduced 15Aug17 @CR

    // set up core variables as session variables ...
    for ($i=0; $i<count($core); $i++) {

        if (in_array($core[$i][0],$web_reg_post_fields)) {
            $core_key = $core[$i][0];
            $$core_key = $core[$i][1];
            $_SESSION[$core_key] = $$core_key;
        } //endif

    } //endfor

} //endif

fdebug ("session.vars.core=>" . print_r($_SESSION,true) . "<");

$sql = "select field_name from campaign_fields";
$sql .= " where campaign_id = " . $campaign_id;
$sql .= " and session_prepop_ptv_flg = 1";

$result = mysql_query($sql,$connection);

if (!$result) {
    fdebug ("bad.sql=>" . $sql . "<");
} //endif

while ($result_row = mysql_fetch_assoc($result)) {
    // eg this will create a session variable like:
    // $_SESSION['c284_prepop_energysupplier'] = $_POST['m_energysupplier'];
    $field_name = $result_row['field_name'];
    $prepop_sess_var = 'c' . $campaign_id . '_prepop_' . $field_name;
    $post_var = 'm_' . $field_name;
    $_SESSION[$prepop_sess_var] = $_POST[$post_var];
} //endif

$web_reg_uid = $_SESSION['web_reg_uid']; // added 15Aug17 @CR

// Now we need to send all the campaigns to Verify
$now = date("d/m/Y H:m:s");
$nowt = date("Y-m-d H:m:s");

$url = 'https://verifyleads.co.uk/verify.php';

for ($i=0; $i<count($campaign_list); $i++) {
    unset($fields);
    $campaign_id = $campaign_list[$i][0];
    $fields = array(
            'supplier_id'=>urlencode($supplier_id),
            'campaign_id'=>urlencode($campaign_id)
    );

    for ($k=0; $k<count($core); $k++ ) {
        $fields[$core[$k][0]] = $core[$k][1];
    } //endif

    $ivals = count($campaign[$campaign_id]);

    for($j=0; $j<$ivals; $j++) {
        $arr = $campaign[$campaign_id][$j];
        $fields[$arr[0]] = $arr[1];
    }

    $result="not sent";

    $fields["dob_text"]=$fields["dob_day"] . "/" . $fields["dob_month"] . "/" . $fields["dob_year"];

    $fields_string = "";
    //url-ify the data for the POST
    foreach ($fields as $key=>$value) {
        $fields_string .= $key . '=' . rawurlencode($value) . '&'; // added rawurlencode for each parameter value - 31Oct16 @CR
    }

    $fields_string = rtrim($fields_string,'&');

    //fdebug ("fields_string=>" . $fields_string . "<");

    //open connection
    $ch = curl_init();

    //set the url, number of POST vars, POST data
    curl_setopt($ch,CURLOPT_URL,$url);
    //curl_setopt($ch,CURLOPT_POST,count($fields));
    //curl_setopt($ch,CURLOPT_MUTE,false);
    curl_setopt($ch,CURLOPT_POST,true);
    curl_setopt($ch,CURLOPT_POSTFIELDS,$fields_string);
    curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);

    //execute post
    $result = curl_exec($ch);
    $response = curl_getinfo( $ch );
    //close connection
    curl_close($ch);

    //fdebug ("17>" . $url . "?" . $fields_string . "<");

    //fdebug("verify.response=>" . print_r($response,true) . "<");
    //fdebug("verify.result=>" . print_r($result,true) . "<");

    // Something that was more of an issue with data coming from offerboard web pages, but should be applied to regular web form data too ...
    // (back in Nov 2016) warnings in /var/spool/mail/verify eg. ...
    // Warning: simplexml_load_string(): code>8</return_code><return_description>Invalid phone number: 0<202d><202d>07903836465
    // changed it to utf8_encode it
    // re: http://stackoverflow.com/questions/2507608/error-input-is-not-proper-utf-8-indicate-encoding-using-phps-simplexml-lo
    // look for: 'i solved this using' on web page
    $result_content = utf8_encode($result);
    $xmlResponseFromVerify = json_decode(json_encode((array)simplexml_load_string($result_content)),1);

    /**********************************
    fdebug ("xml9c=>" . print_r($xmlResponseFromVerify,true) . "<");
    foreach($xmlResponseFromVerify as $k) {
        fdebug ("xml9b=>" . $k . "<");
    }
    fdebug ("xml9d=>" . $xmlResponseFromVerify['return_code'] . "<");
    fdebug ("xml9e=>" . $xmlResponseFromVerify['return_description'] . "<");
    fdebug ("xml9f=>" . $xmlResponseFromVerify['individual_id'] . "<");
    **********************************/

    $return_code = $xmlResponseFromVerify['return_code'];
    $return_description = $xmlResponseFromVerify['return_description'];
    $individual_id = $xmlResponseFromVerify['individual_id'];

    $_SESSION['verify_return_code'] = $return_code;
    $_SESSION['verify_return_description'] = $return_description;
    $_SESSION['verify_individual_id'] = $individual_id;

    // mailjet info added to Verify DB ...
    $mailjet_id = $_SESSION['m_mailjet_id'];
    $email = $_SESSION['m_email'];
    $firstname = $_SESSION['m_firstname'];
    $lastname = $_SESSION['m_surname'];

    if ($return_code == 0 && $return_description == 'Success' && !empty($mailjet_id)) {
        // a successful lead was added in Verify, but only add to our mailjet lead DB if a mailjet ID is present (ie has a value from the web form)
        addMailjetLead($individual_id,$mailjet_id,$email,$firstname,$lastname);
    } //endif
    // to here - mailjet info added to Verify DB ...
}

fdebug ("posttoverify.near.end.session=>" . print_r($_SESSION,true) . "<");

header("Location: " . $nextpage);

exit(0);

?>
